#!/bin/bash

LABEL="Elasticsearch"
SEARCH_GUARD_DIR="./plugins/search-guard-6"

: ${ELASTIC_SEARCH_URL:="http://localhost:9200"}
: ${ELASTIC_SEARCH_USERNAME:="elastic1"}
: ${ELASTIC_SEARCH_PASSWORD:="elastic@123"}

log() {
    echo -e "$1"
}


# Source: https://gist.github.com/sj26/88e1c6584397bb7c13bd11108a579746
function retry {
  local retries=$1
  shift

  local count=0
  until "$@"; do
    exit=$?
    wait=$((5 ** $count))
    count=$(($count + 1))
    if [ $count -lt $retries ]; then
      echo "Retry $count/$retries exited $exit, retrying in $wait seconds..."
      sleep $wait
    else
      echo "Retry $count/$retries exited $exit, no more retries left."
      exit 1 #return $exit
    fi
  done
  return 0
}

log "Waiting for $LABEL to get ready using the commands: \"curl --user <credentials> \"$ELASTIC_SEARCH_URL/_cluster/health?pretty=true\"\""
retry 5 curl --silent --output /dev/null --user ${ELASTIC_SEARCH_USERNAME}:${ELASTIC_SEARCH_PASSWORD} "$ELASTIC_SEARCH_URL/_cluster/health?pretty=true"

log "$LABEL is ready. Executing commands"

if [ ! -d "${SEARCH_GUARD_DIR}" ]; then
    echo "Unable to find ${SEARCH_GUARD_DIR} (SEARCH_GUARD_DIR) directory, please install secure guard plugin and retry"
    exit 1
fi

cd ${SEARCH_GUARD_DIR}/tools && ./sgadmin.sh -ts truststore.jks -tspass 2a3fd7b2c5b5aa1b44bc -ks CN=sgadmin-keystore.jks -kspass 21bb9c6edc3224da28af -nhnv -icl -cd ../sgconfig/
exit $?
